--------------------------
---The mod built by HWY---
--------------------------
--Functuon definition	
local character_health = GetModConfigData("character_health")
local character_sanity = GetModConfigData("character_sanity")
local character_hunger = GetModConfigData("character_hunger")
local unlock_characters = GetModConfigData("unlock_characters")
local reveal_map = GetModConfigData("reveal_map")
local onex = (GetModConfigData("faster_speed")=="onex")
local opfx = (GetModConfigData("faster_speed")=="opfx")
local optfx = (GetModConfigData("faster_speed")=="optfx")
local nnstack = (GetModConfigData("more_stacking")=="nnstack")
local stack2 = (GetModConfigData("more_stacking")=="stack2")
local quickpick = GetModConfigData("quick_pick")
local tool = GetModConfigData("tools")
local logs = GetModConfigData("log")
local setskin = GetModConfigData("snakeskin")
local bpack = GetModConfigData("setbackpack")
local con4 = (GetModConfigData("content")=="con4")
local con5 = (GetModConfigData("content")=="con5")
local krampus1 = GetModConfigData("krampus_ice")
local fish = GetModConfigData("fishing_time")
local ttorch = (GetModConfigData("torch_time")=="ttorch")
local ottorch = (GetModConfigData("torch_time")=="ottorch")
local tstackable= GetModConfigData("tool_stackable")
local cook1 = (GetModConfigData("cook_time")=="cook1")
local cook2 = (GetModConfigData("cook_time")=="cook2")
local bl1 = (GetModConfigData("bl_time")=="bl1")
local bl2 = (GetModConfigData("bl_time")=="bl2")
local ice1 = (GetModConfigData("icebox_time")=="ice1")
local ice2 = (GetModConfigData("icebox_time")=="ice2")
local ice3 = (GetModConfigData("icebox_time")=="ice3")
local butter2 = (GetModConfigData("butter_drop")=="butter2")
local seg_time = 30
local dusk_segs = 4
local night_segs = 2
local night_time = seg_time * night_segs
local dusk_time = seg_time * dusk_segs

--config
Assets =
{
	Asset("IMAGE", "scripts/images/4x4.tex" ),
	Asset("ATLAS", "scripts/images/4x4.xml" ),
	Asset("IMAGE", "scripts/images/5x5.tex" ),
	Asset("ATLAS", "scripts/images/5x5.xml" ),
	Asset("IMAGE", "scripts/images/2x7.tex" ),
	Asset("ATLAS", "scripts/images/2x7.xml" ),
}

--log
if logs then
if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then
PrefabFiles =
{
	"jungletreelog",
	"evergreenlog",
	"deciduoustreelog",	
}
elseif GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then
PrefabFiles =
{
	"evergreenlog",
	"deciduoustreelog",
}
elseif GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
PrefabFiles =
{
	"jungletreelog",
	"evergreenlog",
	"deciduoustreelog",
	"rainforesttreelog",
	"clawpalmtreelog",
	"teatreeslog",	
}
else
PrefabFiles =
{
	"everlog",
}
end
end

--snakeskin
if setskin then
local function set_skin(inst)
    inst.components.lootdropper:AddRandomLoot("monstermeat", 1.00)
	inst.components.lootdropper:AddRandomLoot("snakeskin", 1.00)
	inst.components.lootdropper.numrandomloot = 1
end
AddPrefabPostInit("snake", set_skin)
end

--backpack
if bpack then
local function set_backpack(inst)
local slotpos = {}
local Vector3 = GLOBAL.Vector3
for y = 0, 6 do
	table.insert(slotpos, Vector3(-40, -y*75 + 235 ,0))
	table.insert(slotpos, Vector3(35, -y*75 + 235 ,0))
end
    inst.components.container.widgetslotpos = slotpos
	inst.components.container:SetNumSlots(#slotpos)
	inst.components.container.widgetanimbank = nil
	inst.components.container.widgetanimbuild = nil
	inst.components.container.widgetpos = Vector3(-80,-110,0)
	inst.components.container.widgetbgatlas = "scripts/images/2x7.xml"
	inst.components.container.widgetbgimage = "2x7.tex"
end
AddPrefabPostInit("piggyback", set_backpack)
end


--content
if con4 then
local function set_chest(inst)
local slotpos = {}
local Vector3 = GLOBAL.Vector3
for y = 3, 0, -1 do
	for x = 0, 3 do
		table.insert(slotpos, Vector3(80*x-80*2+17, 80*y-80*2+68, 0))
	end
end
	inst.components.container.widgetslotpos = slotpos
	inst.components.container:SetNumSlots(#slotpos)
	inst.components.container.widgetpos = Vector3(0,240,0)
	inst.components.container.widgetanimbank = nil
	inst.components.container.widgetanimbuild = nil
	inst.components.container.widgetbgatlas = "scripts/images/4x4.xml"
	inst.components.container.widgetbgimage = "4x4.tex"
end
AddPrefabPostInit("treasurechest", set_chest)
AddPrefabPostInit("icebox", set_chest)
elseif con5 then
local function set_chest(inst)
local slotpos = {}
local Vector3 = GLOBAL.Vector3
for y = 4, 0, -1 do
	for x = 0, 4 do
		table.insert(slotpos, Vector3(80*x-80*2-28, 80*y-80*2+35, 0))
	end
end
	inst.components.container.widgetslotpos = slotpos
    inst.components.container:SetNumSlots(#slotpos)
	inst.components.container.widgetpos = Vector3(0,240,0)
	inst.components.container.widgetanimbank = nil
	inst.components.container.widgetanimbuild = nil
	inst.components.container.widgetbgatlas = "scripts/images/5x5.xml"
	inst.components.container.widgetbgimage = "5x5.tex"
end
AddPrefabPostInit("treasurechest", set_chest)
AddPrefabPostInit("icebox", set_chest)
end

--butter
if butter2 then
local function set_butter(inst)
	inst.components.lootdropper:AddRandomLoot("butter", 1)
    inst.components.lootdropper:AddRandomLoot("butterflywings", 9)
	inst.components.lootdropper.numrandomloot = 1
end
AddPrefabPostInit("butterfly", set_butter)
end


--krampus sack
if krampus1 then
local function set_krampus(inst)
    inst:AddTag("fridge")
end
AddPrefabPostInit("krampus_sack", set_krampus)
end

--icebox
if ice1 then
TUNING.PERISH_FRIDGE_MULT = .1
elseif ice2 then 
TUNING.PERISH_FRIDGE_MULT = .05
elseif ice3 then
TUNING.PERISH_FRIDGE_MULT = 0
end


--bottle lantern
if bl1 then
TUNING.BOAT_LANTERN_LIGHTTIME = (night_time+dusk_time)*13
TUNING.MINERHAT_LIGHTTIME = (night_time+dusk_time)*13
TUNING.BOTTLE_LANTERN_LIGHTTIME = (night_time+dusk_time)*13
elseif bl2 then
TUNING.BOAT_LANTERN_LIGHTTIME = (night_time+dusk_time)*26
TUNING.MINERHAT_LIGHTTIME = (night_time+dusk_time)*26
TUNING.BOTTLE_LANTERN_LIGHTTIME = (night_time+dusk_time)*26
end

--fishing
if fish then
local function set_fish(inst)
    inst.components.fishingrod:SetWaitTimes(0, 0)
end
AddPrefabPostInit("fishingrod", set_fish)
end

--cook
if cook1 then
TUNING.BASE_COOK_TIME = night_time*.111
elseif cook2 then
TUNING.BASE_COOK_TIME = night_segs*.01
end


--torch
if ttorch then
TUNING.BOAT_TORCH_LIGHTTIME = night_time*3.5
TUNING.TORCH_FUEL = night_time*2.50
elseif ottorch then
TUNING.BOAT_TORCH_LIGHTTIME = night_time*5.25
TUNING.TORCH_FUEL = night_time*3.75
end

--tool
if tool then
ACTIONS = GLOBAL.ACTIONS
local function set_chop(inst)
	inst.components.tool:SetAction(ACTIONS.CHOP, 15)
end
AddPrefabPostInit("axe", set_chop)
AddPrefabPostInit("goldenaxe", set_chop)
AddPrefabPostInit("axe_obsidian", set_chop)
local function set_mine(inst)
	inst.components.tool:SetAction(ACTIONS.MINE, 15)
    inst.components.finiteuses:SetConsumption(ACTIONS.MINE, 0.33)	
end
AddPrefabPostInit("pickaxe", set_mine)
AddPrefabPostInit("goldenpickaxe", set_mine)
local function set_hack(inst)
	inst.components.tool:SetAction(ACTIONS.HACK, 15)
end
AddPrefabPostInit("machete", set_hack)
AddPrefabPostInit("goldenmachete", set_hack)
AddPrefabPostInit("machete_obsidian", set_hack)
local function set_dig(inst)
    inst.components.tool:SetAction(ACTIONS.DIG, 15)
    inst.components.finiteuses:SetConsumption(ACTIONS.DIG, 0.25)	
end
AddPrefabPostInit("shovel", set_dig)
AddPrefabPostInit("goldenshovel", set_dig)
local function set_shear(inst)
    inst.components.finiteuses:SetConsumption(ACTIONS.SHEAR, 0.2)
end
AddPrefabPostInit("shears", set_shear)
end

--pick
if quickpick then
ACTIONS = GLOBAL.ACTIONS
local function set_pick(inst)
	inst.components.pickable.quickpick=true
end
ActionHandler = GLOBAL.ActionHandler
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.HARVEST, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.HARVEST, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.COOK, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.COOK, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.PICK, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.PICK, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.PICKUP, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.PICKUP, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.MURDER, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.MURDER, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.SHAVE, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.SHAVE, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.BUILD, "doshortaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(ACTIONS.BUILD, "doshortaction"))
end

--stack
if nnstack then
TUNING.STACK_SIZE_LARGEITEM = 99;
TUNING.STACK_SIZE_MEDITEM = 99;
TUNING.STACK_SIZE_SMALLITEM = 99;
elseif stack2 then
TUNING.STACK_SIZE_LARGEITEM = 999;
TUNING.STACK_SIZE_MEDITEM = 999;
TUNING.STACK_SIZE_SMALLITEM = 999;
end

--speed
if opfx then
TUNING.WILSON_WALK_SPEED = 6;
TUNING.WILSON_RUN_SPEED = 9;
TUNING.WOODLEGS_WALK_SPEED = 3;
TUNING.WOODLEGS_RUN_SPEED = 6;
elseif optfx then
TUNING.WILSON_WALK_SPEED = 5;
TUNING.WILSON_RUN_SPEED = 7.5;
TUNING.WOODLEGS_WALK_SPEED = 2.5;
TUNING.WOODLEGS_RUN_SPEED = 5;
end

--sanity
if character_sanity then
TUNING.WILSON_SANITY = 300
TUNING.WILSON_SANITY = 300
TUNING.WILLOW_SANITY = 300
TUNING.WEBBER_SANITY = 300
TUNING.WALANI_SANITY = 300
TUNING.WILBUR_SANITY = 300
TUNING.WILBA_SANITY = 300
TUNING.WHEELER_SANITY = 300
TUNING.WATHGRITHR_SANITY = 300
TUNING.WICKERBOTTOM_SANITY = 300
TUNING.WX78_MIN_SANITY = 300
TUNING.WX78_MAX_SANITY = 300
local function set_sanity(inst)
	inst.components.sanity:SetMax(300)	
end
AddPrefabPostInit("wes", set_sanity)
AddPrefabPostInit("wormwood", set_sanity)
AddPrefabPostInit("wagstaff", set_sanity)
end

--hunger
if character_hunger then
TUNING.WILSON_HUNGER = 300
TUNING.WARLY_HUNGER = 300
TUNING.WEBBER_HUNGER = 300
TUNING.WALANI_HUNGER = 300
TUNING.WILBUR_HUNGER = 300
TUNING.WILBA_HUNGER = 300
TUNING.WHEELER_HUNGER = 300
TUNING.WATHGRITHR_HUNGER = 300
TUNING.WX78_MIN_HUNGER = 300
TUNING.WX78_MAX_HUNGER = 300
local function set_hunger(inst)
	inst.components.hunger:SetMax(300)	
end
AddPrefabPostInit("wes", set_hunger)
AddPrefabPostInit("wormwood", set_hunger)
AddPrefabPostInit("wolfgang", set_hunger)
AddPrefabPostInit("wagstaff", set_hunger)
end

--health
if character_health then
TUNING.WEBBER_HEALTH = 300
TUNING.WALANI_HEALTH = 300
TUNING.WILBUR_HEALTH = 300
TUNING.WILBA_HEALTH = 300
TUNING.WHEELER_HEALTH = 300
TUNING.WOLFGANG_HEALTH_NORMAL = 300
TUNING.WX78_MIN_HEALTH = 300
TUNING.WX78_MAX_HEALTH = 300
local function blood(inst)
	inst.components.health:SetMaxHealth(300)
end
AddPrefabPostInit("wilson", blood)
AddPrefabPostInit("willow", blood)
AddPrefabPostInit("wendy", blood)
AddPrefabPostInit("wickerbottom", blood)
AddPrefabPostInit("woodie", blood)
AddPrefabPostInit("waxwell", blood)
AddPrefabPostInit("warly", blood)
AddPrefabPostInit("woodlegs", blood)
AddPrefabPostInit("wathgrithr", blood)
AddPrefabPostInit("wormwood", blood)
AddPrefabPostInit("wes", blood)
AddPrefabPostInit("wagstaff", blood)
end


--character
if unlock_characters then
function unlockcharacter(inst)
	local character = GLOBAL.PlayerProfile
	character.IsCharacterUnlocked = function()
        	return true
	end
end
AddGamePostInit(unlockcharacter)
end

--map
if reveal_map then
local function revealer(inst)

	GLOBAL.RunScript("consolecommands")
	
	inst:DoTaskInTime( 0.001, function() 
	
				minimap = TheSim:FindFirstEntityWithTag("minimap")
				minimap.MiniMap:ShowArea(0,0,0,40000)
	end)

end
AddSimPostInit(revealer)
end