name = "Tutorial Mods"
description = "The mod is made for accelerating the game progress"
author = "HWY"
icon_atlas = "mods.xml"
icon = "modicon.tex"
version = "1.2.0"

api_version = 6
api_version_dst = 10

dont_starve_compatible = true
reign_of_giants_compatible = true
shipwrecked_compatible = true
hamlet_compatible = true
dst_compatible = true
client_only_mod = false
all_clients_require_mod = true

restart_required = false
forumthread = ""

configuration_options = 
{
	{
		name = "character_hunger",
		label = "Hunger",
		options = 
		{
			{description = "default", data = false},
			{description = "300", data = true},
		},
		default = false
	},
	{
		name = "character_sanity",
		label = "Sanity",
		options = 
		{
			{description = "default", data = false},
			{description = "300", data = true},
		},
		default = false
	},
	{
		name = "character_health",
		label = "Health",
		options = 
		{
		    {description = "default", data = false},
			{description = "300", data = true},
			
		},
		default = false
	},
	{
		name = "quick_pick",
		label = "Pick",
		options = 
		{
			{description = "default", data = false},
			{description = "quick", data = true},

		},
		default = true
	},	
		{
		name = "tools",
		label = "Chop",
		options = 
		{
			{description = "default", data = false},
			{description = "one time", data = true},

		},
		default = false
	},
	{
		name = "cook_time",
		label = "Cook",
		options = 
		{
			{description = "default", data = false},
			{description = "quick", data = "cook1"},
			{description = "instant", data = "cook2"},
		},
		default = "cook1"
	},
	{
		name = "fishing_time",
		label = "Fishing",
		options = 
		{
			{description = "default", data = false},
			{description = "instant", data = true},
		},
		default = true
	},
	{
		name = "faster_speed",
		label = "Speed",
		options = 
		{
			{description = "default", data = false},
			{description = "1.25x", data = "optfx"},
			{description = "1.50x", data = "opfx"},
		},
		default = false
	},
	{
		name = "more_stacking",
		label = "Stack",
		options = 
		{
			{description = "default", data = false},
			{description = "99", data = "nnstack"},
			{description = "999", data = "stack2"}
		},
		default = "stack2"
	},
	{
		name = "torch_time",
		label = "Torch",
		options = 
		{
			{description = "default", data = false},
			{description = "2.0x", data = "ttorch"},
			{description = "3.0x", data = "ottorch"}
		},
		default = false
	},
	{
		name = "bl_time",
		label = "Biolantern",
		options = 
		{
			{description = "default", data = false},
			{description = "5.0x", data = "bl1"},
			{description = "10.0x", data = "bl2"}
		},
		default = false
	},
	{
		name = "content",
		label = "Container",
		options = 
		{
			{description = "default", data = false},
			{description = "4x4", data = "con4"},
			{description = "5x5", data = "con5"}
		},
		default = false
	},
	{
		name = "setbackpack",
		label = "Piggyback",
		options = 
		{
			{description = "default", data = false},
			{description = "2x7", data = true}
		},
		default = false
	},
	{
		name = "icebox_time",
		label = "Icebox",
		options = 
		{
			{description = "default", data = false},
			{description = "5.0x", data = "ice1"},
			{description = "10.0x", data = "ice2"},
			{description = "forever", data = "ice3"}
		},
		default = "ice1"
	},
	{
		name = "krampus_ice",
		label = "Kramsack",
		options = 
		{
			{description = "default", data = false},
			{description = "icebox", data = true}

		},
		default = false
	},
	{
		name = "butter_drop",
		label = "Butter",
		options = 
		{
			{description = "default", data = false},
			{description = "more", data = "butter2"}

		},
		default = false
	},
	{
		name = "snakeskin",
		label = "Snakeskin",
		options = 
		{
			{description = "default", data = false},
			{description = "more", data = true}

		},
		default = false
	},
	{
		name = "log",
		label = "Log",
		options = 
		{
			{description = "default", data = false},
			{description = "2x", data = true}

		},
		default = false
	},
	{
		name = "unlock_characters",
		label = "Character",
		options = 
		{
			{description = "default", data = false},
			{description = "unlock", data = true}

		},
		default = false
	},	
	{
		name = "reveal_map",
		label = "Map",
		options = 
		{
			{description = "default", data = false},
			{description = "reveal", data = true}

		},
		default = false
	}
}